document.write("<script src='../js/ajax.js'></script>");

(function(w){
	/**
	 * 淘闲置获取闲置分类列表
	 * @param {Object} options
	 */
	w.ajax_getAllLeaveType = function(options) {
		startLoad();
		console.log("ajax_getAllLeaveType");
		var data = getdata(options,'com.ijih.jsonws.member.LeaveWS.getAllLeaveType');
		mui.ajax(httpUrl,{
			data:data,
			dataType:'json',//服务器返回json格式数据
			type:'get',//HTTP请求类型
			timeout:10000,//超时时间设置为10秒；
			success:function(data){
				logData(data);
				setTimeout(function(){
					endLoad();
					setTaoIdleTypes(data);
				},500);
			},
			error:function(xhr,type,errorThrown){
				endLoad();
				console.log("ajax Error!"+"\r\n"+"xhr:"+"\r\n"+"type:"+type+"\r\n"+"errorThrown:"+errorThrown+"\r\n");
			}
		});
	}
	
	/**
	 * 获取闲置分类下拉列表
	 * @param {Object} options
	 */
	w.ajax_getLeaveTypes = function(options) {
		console.log("ajax_getAllLeaveType");
		var data = getdata(options,'com.ijih.jsonws.member.LeaveWS.getAllLeaveType');
		mui.ajax(httpUrl,{
			data:data,
			dataType:'json',//服务器返回json格式数据
			type:'get',//HTTP请求类型
			timeout:10000,//超时时间设置为10秒；
			success:function(data){
				setTimeout(function(){
					var pickerJson=new Array();
					var typelist = data.data;
					for (var i = 0; i < typelist.length; i++) {
						var aar = {
							value: typelist[i].id+"",
							text:typelist[i].name+""
						};
						console.log(JSON.stringify(aar));
						pickerJson.push(aar);
					}
					allIdleTypeSuccess(pickerJson);
				},500);
			},
			error:function(xhr,type,errorThrown){
				console.log("ajax Error!"+"\r\n"+"xhr:"+"\r\n"+"type:"+type+"\r\n"+"errorThrown:"+errorThrown+"\r\n");
			}
		});
	}
	
	
	/**
	 * 获取淘闲置类型对应的分类列表
	 * @param {Object} options
	 */
	w.ajax_getIdleList = function(options,pageNum,pageSize,isDown) {
		startLoad();
		console.log("getAllLeave");
		var data = getdata(options,'com.ijih.jsonws.member.LeaveWS.getAllLeave');
		mui.ajax(httpUrl,{
			data:data,
			dataType:'json',//服务器返回json格式数据
			type:'get',//HTTP请求类型
			timeout:10000,//超时时间设置为10秒；
			success:function(data){
				logData(data);
				setTimeout(function(){
					endLoad();
					setIdleList(data,pageNum,pageSize,isDown);
				},500);
			},
			error:function(xhr,type,errorThrown){
				endLoad();
				console.log("ajax Error!"+"\r\n"+"xhr:"+"\r\n"+"type:"+type+"\r\n"+"errorThrown:"+errorThrown+"\r\n");
			}
		});
	}
	
	/**
	 * 添加淘闲置
	 * @param {Object} options
	 */
	w.ajax_creatIdle = function(options) {
		startLoad();
		console.log("addLeave");
		var data = getdata(options,'com.ijih.jsonws.member.LeaveWS.addLeave');
		mui.ajax(httpUrl,{
			data:data,
			dataType:'json',//服务器返回json格式数据
			contentType:"UTF-8",
			type:'get',//HTTP请求类型
			timeout:10000,//超时时间设置为10秒；
			success:function(data){
				logData(data);
				setTimeout(function(){
					endLoad();
					addIdleCallBack(data);
				},500);
			},
			error:function(xhr,type,errorThrown){
				endLoad();
				console.log("ajax Error!"+"\r\n"+"xhr:"+"\r\n"+"type:"+type+"\r\n"+"errorThrown:"+errorThrown+"\r\n");
			}
		});
	}
	
	//获取淘闲置详情
	w.ajax_getLeaveInfo = function(options){
		startLoad();
		console.log("getLeaveInfo");
		var data = getdata(options,'com.ijih.jsonws.member.LeaveWS.getLeaveInfo');
		mui.ajax(httpUrl,{
			data:data,
			dataType:'json',//服务器返回json格式数据
			contentType:"UTF-8",
			type:'get',//HTTP请求类型
			timeout:10000,//超时时间设置为10秒；
			success:function(data){
				logData(data);
				setTimeout(function(){
					endLoad();
					setIdleInfoCallBack(data);
				},500);
			},
			error:function(xhr,type,errorThrown){
				endLoad();
				console.log("ajax Error!"+"\r\n"+"xhr:"+"\r\n"+"type:"+type+"\r\n"+"errorThrown:"+errorThrown+"\r\n");
			}
		});
	}
	
	/**
	 * 添加淘闲置信息评论
	 * @param {Object} options
	 */
	w.ajax_addLeavereview = function(options) {
		startLoad();
		console.log("addLeavereview");
		var data = getdata(options,'com.ijih.jsonws.member.LeaveWS.addLeavereview');
		mui.ajax(httpUrl,{
			data:data,
			dataType:'json',//服务器返回json格式数据
			contentType:"UTF-8",
			type:'get',//HTTP请求类型
			timeout:10000,//超时时间设置为10秒；
			success:function(data){
				logData(data);
				setTimeout(function(){
					endLoad();
					submitCommentSuccess(data);
				},500);
			},
			error:function(xhr,type,errorThrown){
				endLoad();
				console.log("ajax Error!"+"\r\n"+"xhr:"+"\r\n"+"type:"+type+"\r\n"+"errorThrown:"+errorThrown+"\r\n");
			}
		});
	}
	
	/**
	 * 获取淘闲置评论
	 * @param {Object} options
	 */
	w.ajax_getLeavereview = function(options){
		startLoad();
		console.log("getLeavereview");
		var data = getdata(options,'com.ijih.jsonws.member.LeaveWS.getLeavereview');
		mui.ajax(httpUrl,{
			data:data,
			dataType:'json',//服务器返回json格式数据
			contentType:"UTF-8",
			type:'get',//HTTP请求类型
			timeout:10000,//超时时间设置为10秒；
			success:function(data){
				logData(data);
				setTimeout(function(){
					endLoad();
					setIdleCommentCallBack(data);
				},500);
			},
			error:function(xhr,type,errorThrown){
				endLoad();
				console.log("ajax Error!"+"\r\n"+"xhr:"+"\r\n"+"type:"+type+"\r\n"+"errorThrown:"+errorThrown+"\r\n");
			}
		});
	}
	
	/**
	 * 用户添加对象到收藏夹
	 **/
	w.ajax_member_addIdleCollect = function(inputData,callback) {
		callback = callback || $.noop;
		inputData = inputData || {};
		var postDataJson = getdata(inputData,'com.ijih.jsonws.member.MemberWS.addMemberCollect');
		mui.ajax(httpUrl,{
			data:postDataJson,
			dataType:'json',
			type:'get',
			timeout:10000,
			success:function(response){
				setTimeout(function(){
					submitIdleCollectPostSuccess(response);
				},500);
					
			},
			error:function(xhr,type,errorThrown){
				if(type == "timeout"){
					plus.nativeUI.toast("您的网络不太通畅哦~");
				}
			}
		});
	};
	
	
}(window));