/*
 * 图片上传页面需要引入该js文件
 */
var imgidvalue = '';//定位操作的图片div位置
var imageUrlLists = ''; //上传图片的url相对路径

//定义图片上传图标和事件
(function(mui, window, document, undefined) {
	mui.init();
	var get = function(id) {
		return document.getElementById(id);
	};
	var qsa = function(sel) {
		return [].slice.call(document.querySelectorAll(sel));
	};
	var ui = {
		imageList: get('image-list'),
		submit: get('submit')
	};
	ui.clearForm = function() {
		ui.imageList.innerHTML = '';
		ui.newPlaceholder();
	};
	ui.getFileInputArray = function() {
		return [].slice.call(ui.imageList.querySelectorAll('input[type="file"]'));
	};
	ui.getFileValueArray = function() {
		var fileInputArray = ui.getFileInputArray();
		//console.log(fileInputArray.innerHTML);
		var idArray = [];
		fileInputArray.forEach(function(fileInput) {
			//console.log(fileInput.innerHTML);
			if (fileInput.value != '') {
				idArray.push(fileInput.getAttribute('src'));
			}
		});
		return idArray;
	};
	ui.getFileInputIdArray = function() {
		var fileInputArray = ui.getFileInputArray();
		var idArray = [];
		fileInputArray.forEach(function(fileInput) {
			if (fileInput.value != '') {
				idArray.push(fileInput.getAttribute('id'));
			}
		});
		return idArray;
	};
	var imageIndexIdNum = 0;
	ui.newPlaceholder = function() {
		var fileInputArray = ui.getFileInputArray();
		if (fileInputArray &&
			fileInputArray.length > 0 &&
			fileInputArray[fileInputArray.length - 1].parentNode.classList.contains('space')) {
			return;
		}
		imageIndexIdNum++;
		var placeholder = document.createElement('div');
		placeholder.setAttribute('class', 'image-item space');
		var closeButton = document.createElement('div');
		closeButton.setAttribute('class', 'image-close');
		closeButton.innerHTML = 'X';
		closeButton.addEventListener('click', function(event) {
			event.stopPropagation();
			event.cancelBubble = true;
			setTimeout(function() {
				ui.imageList.removeChild(placeholder);
			}, 0);
			return false;
		}, false);
		var fileInput = document.createElement('img');
		//fileInput.setAttribute("id", "__mui-imageview__");
		fileInput.classList.add("image-list-li");
		fileInput.classList.add("mui-slider");
		fileInput.classList.add("mui-fullscreen");
		//fileInput.setAttribute('type', 'file');
		fileInput.setAttribute('accept', 'image/*');
		fileInput.setAttribute('id', 'image-' + imageIndexIdNum);
		fileInput.addEventListener('click', function(event) {
			imgidvalue = 'image-' + imageIndexIdNum;
			if (!imageTool.options.uploadUrl) {
				mui.alert('请填写图片上传链接');
				return;
			}
			// 弹出系统选择按钮框
			plus.nativeUI.actionSheet({
					cancel: "取消",
					buttons: [{
						title: "从手机相册选择"
					}, {
						title: '拍照'
					}]
				},
				function(e) {
					console.log(JSON.stringify(e));
					if (e.index == 1) { //点击从相册选择
						console.log("相册选择");
						getPics();
					} else if (e.index == 2) {
						console.log("拍照");
						getPics(true);
					}
				}
			);

			//placeholder.classList.remove('space');
			//ui.newPlaceholder();
		}, false);

		placeholder.appendChild(closeButton);
		placeholder.appendChild(fileInput);
		ui.imageList.appendChild(placeholder);
	};
	ui.newPlaceholder();

//	ui.submit.addEventListener('tap', function(event) {
//		//plus.nativeUI.showWaiting();
//		//console.log(ui.imageList.innerHTML);
//		ajax_images_send({
//			images: ui.getFileInputIdArray(),
//			imagesurl: ui.getFileValueArray()
//		}, function() {
//			plus.nativeUI.closeWaiting();
//			mui.toast('提交成功!!!');
//			ui.clearForm();
//			mui.back();
//		});
//	}, false);
})(mui, window, document, undefined);

//获取图片
function getPics(isCamera) {
	//plus.nativeUI.showWaiting();
	//可以设置mask
	//main.setStyle({
	//	mask: '#ccc'
	//});
	if (!isCamera) {
		imageTool.galleryImgs(doPics);
	} else {
		imageTool.camera(doPics);
	}
}

//图片上传成功以后回调函数，上传成功以后对页面的具体操作可以写在这里
function doPics(err, list) {
	//因为dcloud官方上传地址上传后返回的格式并不是插件定义的规范，
	//"responseText":"{\"strings\":{\"uid\":\"39106184\",\"client\":\"HelloH5+\"},\"error\":\"0\",\"files\":{\"phillyx_72192431\":{\"name\":\"1464411747097.jpg\",\"url\":\"files\\/1464411747097.jpg\",\"type\":\"image\\/jpeg\",\"size\":245329}}}"
	//所以list内部数据都为空
	var err = '';
	var files = [];
	if (err) {
		console.log(err);
	}
	if (list) {
		mui.each(list, function(index, item) {
			console.log("err " + item.error);
			if (item.imgUrl) {
				files.push(item.imgUrl);
			}
		});
	}
	console.log('上传图片地址：' + JSON.stringify(files));
	//关掉mask
	//main.setStyle({
	//	mask: 'none'
	//});
	
	if (files.length > 0) {
		//在这里做项目的逻辑，可以打开新页面将files传过去
		//document.getElementById(imgidvalue).setAttribute("src",files[0]);
		imageUrlLists='';
		var imageList = document.getElementById("image-list");
		for (var i = 0; i < files.length; i++) {

			var placeholder = document.createElement('div');
			placeholder.setAttribute('class', 'image-item space');
			placeholder.setAttribute("id",files[i]);
			var closeButton = document.createElement('div');
			closeButton.setAttribute('class', 'image-close');
			closeButton.innerHTML = 'X';
			
			var imgobj = document.createElement('img');
			imgobj.classList.add("image-list-li");
			imgobj.classList.add("mui-col-xs-6");
			imgobj.classList.add("mui-slider");
			imgobj.classList.add("mui-fullscreen");
			imgobj.setAttribute("src",files[i]);
			imgobj.setAttribute("alt",files[i]);
			imgobj.setAttribute("data-preview-src","");
			imgobj.setAttribute("data-preview-group","1");
			
			placeholder.classList.remove('space');
			placeholder.appendChild(closeButton);
			placeholder.appendChild(imgobj);
			imageList.appendChild(placeholder);
			
			/*closeButton.addEventListener('click', function(event) {
				event.stopPropagation();
				event.cancelBubble = true;
				setTimeout(function() {
					//var placeholderid = document.getElementById(files[i]);
					//imageList.remove(placeholderid);
					//imageList.removeChild(placeholder);
					//this.parentNode.parentNode.removeChild(this.parentNode);
				}, 100);
				return false;
			}, false);*/
			
//			imageUrlLists = imageUrlLists+files[i]+',' ;//中间需要用逗号隔开
//			if(i==0){
//				imageUrlLists = files[i];
//			}else{
//				imageUrlLists = imageUrlLists+','+files[i] ;//中间需要用逗号隔开
//			}

		}
		
		//console.log("imageUrlLists::"+imageUrlLists);
		
		
		/*
		 * 监听删除图片事件
		 */
		[].forEach.call(document.querySelectorAll(".image-close"), function(item, index) {
			var imagesrc = item.parentNode.getAttribute("id");
			
			if(imagesrc!=undefined && imagesrc!='' && imagesrc!=null){
				imageUrlLists=imageUrlLists+";"+imagesrc;
				console.log("imageUrlLists:"+imageUrlLists);
			}
			
			item.addEventListener('tap', function() {
				var delimagesrc = item.parentNode.getAttribute("id");
			
				if(delimagesrc!=undefined && delimagesrc!='' && delimagesrc!=null){
					imageUrlLists=imageUrlLists.replace(delimagesrc,'');
					console.log("imageUrlLists:"+imageUrlLists);
					var deldata={
						del:'del',
						url:delimagesrc
					};
					mui.ajax(imageUrl+'?del=del&url='+delimagesrc,{
						data:deldata,
						dataType:'html',
						type:'post',
						timeout:10000,
						success:function(data){
							//logData(data);

						},
						error:function(xhr,type,errorThrown){
						}
					});
					
					this.parentNode.parentNode.removeChild(this.parentNode);
				}
				
			});
		});
	}
};


